/* ***********************************************************
 * This file was automatically generated on 2019-12-19.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures two DC currents between 0mA and 20mA (IEC 60381-1)
 */
public class BrickletIndustrialDual020mA extends Device {
	public final static int DEVICE_IDENTIFIER = 228;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Dual 0-20mA Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletindustrialdual020ma", DEVICE_IDENTIFIER, BrickletIndustrialDual020mA.class, BrickletIndustrialDual020mAActions.class, "2.0.1");

	public final static byte FUNCTION_GET_CURRENT = (byte)1;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_SET_SAMPLE_RATE = (byte)8;
	public final static byte FUNCTION_GET_SAMPLE_RATE = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_CURRENT = 10;
	private final static int CALLBACK_CURRENT_REACHED = 11;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static short SAMPLE_RATE_240_SPS = (short)0;
	public final static short SAMPLE_RATE_60_SPS = (short)1;
	public final static short SAMPLE_RATE_15_SPS = (short)2;
	public final static short SAMPLE_RATE_4_SPS = (short)3;

	private List<CurrentListener> listenerCurrent = new CopyOnWriteArrayList<CurrentListener>();
	private List<CurrentReachedListener> listenerCurrentReached = new CopyOnWriteArrayList<CurrentReachedListener>();

	public class CurrentCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletIndustrialDual020mA#setCurrentCallbackPeriod(short, long)}. The parameter is the current of the
	 * sensor.
	 * 
	 * The {@link BrickletIndustrialDual020mA.CurrentListener} listener is only triggered if the current has changed since the
	 * last triggering.
	 */
	public interface CurrentListener extends DeviceListener {
		public void current(short sensor, int current);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletIndustrialDual020mA#setCurrentCallbackThreshold(short, char, int, int)} is reached.
	 * The parameter is the current of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletIndustrialDual020mA#setDebouncePeriod(long)}.
	 */
	public interface CurrentReachedListener extends DeviceListener {
		public void currentReached(short sensor, int current);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialDual020mA(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SAMPLE_RATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SAMPLE_RATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_CURRENT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short sensor = IPConnection.unsignedByte(bb.get());
				int current = (bb.getInt());

				for (CurrentListener listener: listenerCurrent) {
					listener.current(sensor, current);
				}
			}
		};

		callbacks[CALLBACK_CURRENT_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short sensor = IPConnection.unsignedByte(bb.get());
				int current = (bb.getInt());

				for (CurrentReachedListener listener: listenerCurrentReached) {
					listener.currentReached(sensor, current);
				}
			}
		};
	}

	/**
	 * Returns the current of the specified sensor.
	 * 
	 * It is possible to detect if an IEC 60381-1 compatible sensor is connected
	 * and if it works properly.
	 * 
	 * If the returned current is below 4mA, there is likely no sensor connected
	 * or the sensor may be defect. If the returned current is over 20mA, there might
	 * be a short circuit or the sensor may be defect.
	 * 
	 * If you want to get the current periodically, it is recommended to use the
	 * {@link BrickletIndustrialDual020mA.CurrentListener} listener and set the period with
	 * {@link BrickletIndustrialDual020mA#setCurrentCallbackPeriod(short, long)}.
	 */
	public int getCurrent(short sensor) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CURRENT, this);

		bb.put((byte)sensor);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = (bb.getInt());

		return current;
	}

	/**
	 * Sets the period with which the {@link BrickletIndustrialDual020mA.CurrentListener} listener is triggered
	 * periodically for the given sensor. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletIndustrialDual020mA.CurrentListener} listener is only triggered if the current has changed since the
	 * last triggering.
	 */
	public void setCurrentCallbackPeriod(short sensor, long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_CURRENT_CALLBACK_PERIOD, this);

		bb.put((byte)sensor);
		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletIndustrialDual020mA#setCurrentCallbackPeriod(short, long)}.
	 */
	public long getCurrentCallbackPeriod(short sensor) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CURRENT_CALLBACK_PERIOD, this);

		bb.put((byte)sensor);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletIndustrialDual020mA.CurrentReachedListener} listener for the given
	 * sensor.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the current is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the current is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the current is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the current is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setCurrentCallbackThreshold(short sensor, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, this);

		bb.put((byte)sensor);
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletIndustrialDual020mA#setCurrentCallbackThreshold(short, char, int, int)}.
	 */
	public CurrentCallbackThreshold getCurrentCallbackThreshold(short sensor) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, this);

		bb.put((byte)sensor);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CurrentCallbackThreshold obj = new CurrentCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listener
	 * 
	 * * {@link BrickletIndustrialDual020mA.CurrentReachedListener}
	 * 
	 * is triggered, if the threshold
	 * 
	 * * {@link BrickletIndustrialDual020mA#setCurrentCallbackThreshold(short, char, int, int)}
	 * 
	 * keeps being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletIndustrialDual020mA#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the sample rate to either 240, 60, 15 or 4 samples per second.
	 * The resolution for the rates is 12, 14, 16 and 18 bit respectively.
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "0",    "240 samples per second, 12 bit resolution"
	 *  "1",    "60 samples per second, 14 bit resolution"
	 *  "2",    "15 samples per second, 16 bit resolution"
	 *  "3",    "4 samples per second, 18 bit resolution"
	 * \endverbatim
	 */
	public void setSampleRate(short rate) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_SAMPLE_RATE, this);

		bb.put((byte)rate);

		sendRequest(bb.array());
	}

	/**
	 * Returns the sample rate as set by {@link BrickletIndustrialDual020mA#setSampleRate(short)}.
	 */
	public short getSampleRate() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SAMPLE_RATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short rate = IPConnection.unsignedByte(bb.get());

		return rate;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Current listener.
	 */
	public void addCurrentListener(CurrentListener listener) {
		listenerCurrent.add(listener);
	}

	/**
	 * Removes a Current listener.
	 */
	public void removeCurrentListener(CurrentListener listener) {
		listenerCurrent.remove(listener);
	}

	/**
	 * Adds a CurrentReached listener.
	 */
	public void addCurrentReachedListener(CurrentReachedListener listener) {
		listenerCurrentReached.add(listener);
	}

	/**
	 * Removes a CurrentReached listener.
	 */
	public void removeCurrentReachedListener(CurrentReachedListener listener) {
		listenerCurrentReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDual020mA.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDual020mA.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        this.addCurrentListener((sensor, current) -> {if(sensor == 0) {updateStateFn.accept("BrickletIndustrialDual020mACurrentSensor0", transformBrickletIndustrialDual020mACurrentSensor0Callback0(sensor, current, cfg));}});
		this.addCurrentListener((sensor, current) -> {if(sensor == 1) {updateStateFn.accept("BrickletIndustrialDual020mACurrentSensor1", transformBrickletIndustrialDual020mACurrentSensor1Callback0(sensor, current, cfg));}});
        this.setSampleRate(cfg.sampleRate.shortValue());
		{
		BrickletBrickletIndustrialDual020mACurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mACurrentSensor0").as(BrickletBrickletIndustrialDual020mACurrentConfig.class);
		this.setCurrentCallbackPeriod((short)0, channelCfg.updateInterval);
		}
		{
		BrickletBrickletIndustrialDual020mACurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mACurrentSensor1").as(BrickletBrickletIndustrialDual020mACurrentConfig.class);
		this.setCurrentCallbackPeriod((short)1, channelCfg.updateInterval);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        this.listenerCurrent.clear();
		this.listenerCurrent.clear();
        this.setCurrentCallbackPeriod((short)0, 0);
		this.setCurrentCallbackPeriod((short)1, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDual020mACurrentSensor0");
		result.add("BrickletIndustrialDual020mACurrentSensor1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDual020mACurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent"), "NOT USED", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDual020mACurrent")).withDescription("Measured current between 0 and 0.022505322A (22.5mA)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.022505322)).withPattern("%.6f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual 0-20mA Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures two DC currents between 0mA and 20mA (IEC 60381-1)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDual020mACurrentSensor0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent")).withLabel("Current Sensor 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDual020mACurrentSensor1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mACurrent")).withLabel("Current Sensor 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdual020ma":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("3").withDescription("The sample rate to either 240, 60, 15 or 4 samples per second. The resolution for the rates is 12, 14, 16 and 18 bit respectively.").withLabel("Sample Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "240 SPS"), new ParameterOption("1", "60 SPS"), new ParameterOption("2", "15 SPS"), new ParameterOption("3", "4 SPS"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDual020mACurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        switch(channel) {
            case "BrickletIndustrialDual020mACurrentSensor0": {
                   BrickletBrickletIndustrialDual020mACurrentConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialDual020mACurrentConfig.class);
                   {
            int value = this.getCurrent((short)0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mACurrentSensor0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDual020mACurrentSensor1": {
                   BrickletBrickletIndustrialDual020mACurrentConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialDual020mACurrentConfig.class);
                   {
            int value = this.getCurrent((short)1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mACurrentSensor1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDual020mAConfig cfg = (BrickletIndustrialDual020mAConfig) config.as(BrickletIndustrialDual020mAConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor0Callback0(short sensor, int current, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor1Callback0(short sensor, int current, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor0Getter0(int value, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mACurrentSensor1Getter0(int value, BrickletIndustrialDual020mAConfig cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
}
