package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDual020mAActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="int")
           Map<String, Object> brickletIndustrialDual020mAGetCurrent(
            @ActionInput(name = "sensor") short sensor) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mA)this.handler.getDevice()).getCurrent(sensor);
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetCurrent(@Nullable ThingActions actions, short sensor) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetCurrent(sensor);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }

    @RuleAction(label = "Get Sample Rate")
    public @ActionOutput(name = "rate", type="short")
           Map<String, Object> brickletIndustrialDual020mAGetSampleRate(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickletIndustrialDual020mA)this.handler.getDevice()).getSampleRate();
        result.put("rate", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetSampleRate(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetSampleRate();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialDual020mAGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDual020mA.Identity value = ((BrickletIndustrialDual020mA)this.handler.getDevice()).getIdentity();
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }
}
