package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDual020mAV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetCurrent(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getCurrent(channel);
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetCurrent(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetCurrent(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Channel LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getChannelLEDConfig(channel);
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetChannelLEDConfig(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Channel LED Status Config")
    public @ActionOutput(name = "min", type="int")
           @ActionOutput(name = "max", type="int")
           @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDual020mAV2.ChannelLEDStatusConfig value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getChannelLEDStatusConfig(channel);
        result.put("min", value.min);
        result.put("max", value.max);
        result.put("config", value.config);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Sample Rate")
    public @ActionOutput(name = "rate", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetSampleRate(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getSampleRate();
        result.put("rate", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetSampleRate(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetSampleRate();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Gain")
    public @ActionOutput(name = "gain", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetGain(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getGain();
        result.put("gain", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetGain(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetGain();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletIndustrialDual020mAV2ReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        long value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).readUID();
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2ReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2ReadUID();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getChipTemperature();
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetChipTemperature();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getStatusLEDConfig();
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetStatusLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Bootloader Mode")
    public @ActionOutput(name = "mode", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetBootloaderMode(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getBootloaderMode();
        result.put("mode", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetBootloaderMode(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetBootloaderMode();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletIndustrialDual020mAV2GetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDual020mAV2.SPITFPErrorCount value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getSPITFPErrorCount();
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetSPITFPErrorCount();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="int[]")
           @ActionOutput(name = "firmwareVersion", type="int[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDual020mAV2.Identity value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getIdentity();
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).brickletIndustrialDual020mAV2GetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }
}
