/* ***********************************************************
 * This file was automatically generated on 2019-12-19.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

/**
 * Creates beep and alarm with configurable volume and frequency
 */
public class BrickletPiezoSpeakerV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2145;
	public final static String DEVICE_DISPLAY_NAME = "Piezo Speaker Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletpiezospeakerv2", DEVICE_IDENTIFIER, BrickletPiezoSpeakerV2.class, BrickletPiezoSpeakerV2Actions.class, "2.0.2");

	public final static byte FUNCTION_SET_BEEP = (byte)1;
	public final static byte FUNCTION_GET_BEEP = (byte)2;
	public final static byte FUNCTION_SET_ALARM = (byte)3;
	public final static byte FUNCTION_GET_ALARM = (byte)4;
	public final static byte FUNCTION_UPDATE_VOLUME = (byte)5;
	public final static byte FUNCTION_UPDATE_FREQUENCY = (byte)6;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_BEEP_FINISHED = 7;
	private final static int CALLBACK_ALARM_FINISHED = 8;

	public final static long BEEP_DURATION_OFF = 0L;
	public final static long BEEP_DURATION_INFINITE = 4294967295L;
	public final static long ALARM_DURATION_OFF = 0L;
	public final static long ALARM_DURATION_INFINITE = 4294967295L;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<BeepFinishedListener> listenerBeepFinished = new CopyOnWriteArrayList<BeepFinishedListener>();
	private List<AlarmFinishedListener> listenerAlarmFinished = new CopyOnWriteArrayList<AlarmFinishedListener>();

	public class Beep {
		public int frequency;
		public int volume;
		public long duration;
		public long durationRemaining;

		public String toString() {
			return "[" + "frequency = " + frequency + ", " + "volume = " + volume + ", " + "duration = " + duration + ", " + "durationRemaining = " + durationRemaining + "]";
		}
	}

	public class Alarm {
		public int startFrequency;
		public int endFrequency;
		public int stepSize;
		public int stepDelay;
		public int volume;
		public long duration;
		public long durationRemaining;
		public int currentFrequency;

		public String toString() {
			return "[" + "startFrequency = " + startFrequency + ", " + "endFrequency = " + endFrequency + ", " + "stepSize = " + stepSize + ", " + "stepDelay = " + stepDelay + ", " + "volume = " + volume + ", " + "duration = " + duration + ", " + "durationRemaining = " + durationRemaining + ", " + "currentFrequency = " + currentFrequency + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered if a beep set by {@link BrickletPiezoSpeakerV2#setBeep(int, int, long)} is finished
	 */
	public interface BeepFinishedListener extends DeviceListener {
		public void beepFinished();
	}

	/**
	 * This listener is triggered if a alarm set by {@link BrickletPiezoSpeakerV2#setAlarm(int, int, int, int, int, long)} is finished
	 */
	public interface AlarmFinishedListener extends DeviceListener {
		public void alarmFinished();
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletPiezoSpeakerV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BEEP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BEEP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALARM)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALARM)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_UPDATE_VOLUME)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_UPDATE_FREQUENCY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_BEEP_FINISHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (BeepFinishedListener listener: listenerBeepFinished) {
					listener.beepFinished();
				}
			}
		};

		callbacks[CALLBACK_ALARM_FINISHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (AlarmFinishedListener listener: listenerAlarmFinished) {
					listener.alarmFinished();
				}
			}
		};
	}

	/**
	 * Beeps with the given frequency and volume for the duration.
	 * 
	 * A duration of 0 stops the current beep if any is ongoing.
	 * A duration of 4294967295 results in an infinite beep.
	 */
	public void setBeep(int frequency, int volume, long duration) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)15, FUNCTION_SET_BEEP, this);

		bb.putShort((short)frequency);
		bb.put((byte)volume);
		bb.putInt((int)duration);

		sendRequest(bb.array());
	}

	/**
	 * Returns the last beep settings as set by {@link BrickletPiezoSpeakerV2#setBeep(int, int, long)}. If a beep is currently
	 * running it also returns the remaining duration of the beep.
	 * 
	 * If the frequency or volume is updated during a beep (with {@link BrickletPiezoSpeakerV2#updateFrequency(int)}
	 * or {@link BrickletPiezoSpeakerV2#updateVolume(int)}) this function returns the updated value.
	 */
	public Beep getBeep() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BEEP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Beep obj = new Beep();
		obj.frequency = IPConnection.unsignedShort(bb.getShort());
		obj.volume = IPConnection.unsignedByte(bb.get());
		obj.duration = IPConnection.unsignedInt(bb.getInt());
		obj.durationRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Creates an alarm (a tone that goes back and force between two specified frequencies).
	 * 
	 * The following parameters can be set:
	 * 
	 * * Start Frequency: Start frequency of the alarm.
	 * * End Frequency: End frequency of the alarm.
	 * * Step Size: Size of one step of the sweep between the start/end frequencies.
	 * * Step Delay: Delay between two steps (duration of time that one tone is used in a sweep).
	 * * Duration: Duration of the alarm.
	 * 
	 * A duration of 0 stops the current alarm if any is ongoing.
	 * A duration of 4294967295 results in an infinite alarm.
	 * 
	 * Below you can find two sets of example settings that you can try out. You can use
	 * these as a starting point to find an alarm signal that suits your application.
	 * 
	 * Example 1: 10 seconds of loud annoying fast alarm
	 * 
	 * * Start Frequency = 800
	 * * End Frequency = 2000
	 * * Step Size = 10
	 * * Step Delay = 1
	 * * Volume = 10
	 * * Duration = 10000
	 * 
	 * Example 2: 10 seconds of soft siren sound with slow build-up
	 * 
	 * * Start Frequency = 250
	 * * End Frequency = 750
	 * * Step Size = 1
	 * * Step Delay = 5
	 * * Volume = 0
	 * * Duration = 10000
	 * 
	 * The following conditions must be met:
	 * 
	 * * Start Frequency: has to be smaller than end frequency
	 * * End Frequency: has to be bigger than start frequency
	 * * Step Size: has to be small enough to fit into the frequency range
	 * * Step Delay: has to be small enough to fit into the duration
	 */
	public void setAlarm(int startFrequency, int endFrequency, int stepSize, int stepDelay, int volume, long duration) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)21, FUNCTION_SET_ALARM, this);

		bb.putShort((short)startFrequency);
		bb.putShort((short)endFrequency);
		bb.putShort((short)stepSize);
		bb.putShort((short)stepDelay);
		bb.put((byte)volume);
		bb.putInt((int)duration);

		sendRequest(bb.array());
	}

	/**
	 * Returns the last alarm settings as set by {@link BrickletPiezoSpeakerV2#setAlarm(int, int, int, int, int, long)}. If an alarm is currently
	 * running it also returns the remaining duration of the alarm as well as the
	 * current frequency of the alarm.
	 * 
	 * If the volume is updated during an alarm (with {@link BrickletPiezoSpeakerV2#updateVolume(int)})
	 * this function returns the updated value.
	 */
	public Alarm getAlarm() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALARM, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Alarm obj = new Alarm();
		obj.startFrequency = IPConnection.unsignedShort(bb.getShort());
		obj.endFrequency = IPConnection.unsignedShort(bb.getShort());
		obj.stepSize = IPConnection.unsignedShort(bb.getShort());
		obj.stepDelay = IPConnection.unsignedShort(bb.getShort());
		obj.volume = IPConnection.unsignedByte(bb.get());
		obj.duration = IPConnection.unsignedInt(bb.getInt());
		obj.durationRemaining = IPConnection.unsignedInt(bb.getInt());
		obj.currentFrequency = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Updates the volume of an ongoing beep or alarm.
	 */
	public void updateVolume(int volume) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_UPDATE_VOLUME, this);

		bb.put((byte)volume);

		sendRequest(bb.array());
	}

	/**
	 * Updates the frequency of an ongoing beep.
	 */
	public void updateFrequency(int frequency) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_UPDATE_FREQUENCY, this);

		bb.putShort((short)frequency);

		sendRequest(bb.array());
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletPiezoSpeakerV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletPiezoSpeakerV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletPiezoSpeakerV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletPiezoSpeakerV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a BeepFinished listener.
	 */
	public void addBeepFinishedListener(BeepFinishedListener listener) {
		listenerBeepFinished.add(listener);
	}

	/**
	 * Removes a BeepFinished listener.
	 */
	public void removeBeepFinishedListener(BeepFinishedListener listener) {
		listenerBeepFinished.remove(listener);
	}

	/**
	 * Adds a AlarmFinished listener.
	 */
	public void addAlarmFinishedListener(AlarmFinishedListener listener) {
		listenerAlarmFinished.add(listener);
	}

	/**
	 * Removes a AlarmFinished listener.
	 */
	public void removeAlarmFinishedListener(AlarmFinishedListener listener) {
		listenerAlarmFinished.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletPiezoSpeakerV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletPiezoSpeakerV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletPiezoSpeakerV2Config cfg = (BrickletPiezoSpeakerV2Config) config.as(BrickletPiezoSpeakerV2Config.class);
        this.addBeepFinishedListener(() -> {if(true) {updateStateFn.accept("BrickletPiezoSpeakerV2Beep", transformBrickletPiezoSpeakerV2BeepCallback0(cfg));}});
		this.addAlarmFinishedListener(() -> {if(true) {updateStateFn.accept("BrickletPiezoSpeakerV2Alarm", transformBrickletPiezoSpeakerV2AlarmCallback0(cfg));}});
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletBrickletPiezoSpeakerV2BeepConfig channelCfg = getChannelConfigFn.apply("BrickletPiezoSpeakerV2Beep").as(BrickletBrickletPiezoSpeakerV2BeepConfig.class);
		
		}
		{
		BrickletBrickletPiezoSpeakerV2AlarmConfig channelCfg = getChannelConfigFn.apply("BrickletPiezoSpeakerV2Alarm").as(BrickletBrickletPiezoSpeakerV2AlarmConfig.class);
		
		}
		{
		BrickletBrickletPiezoSpeakerV2VolumeConfig channelCfg = getChannelConfigFn.apply("BrickletPiezoSpeakerV2Volume").as(BrickletBrickletPiezoSpeakerV2VolumeConfig.class);
		
		}
		{
		BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig channelCfg = getChannelConfigFn.apply("BrickletPiezoSpeakerV2BeepFrequency").as(BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletPiezoSpeakerV2Config cfg = (BrickletPiezoSpeakerV2Config) config.as(BrickletPiezoSpeakerV2Config.class);
        this.listenerBeepFinished.clear();
		this.listenerAlarmFinished.clear();
        
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletPiezoSpeakerV2Config cfg = (BrickletPiezoSpeakerV2Config) config.as(BrickletPiezoSpeakerV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletPiezoSpeakerV2Beep");
		result.add("BrickletPiezoSpeakerV2Alarm");
		result.add("BrickletPiezoSpeakerV2Volume");
		result.add("BrickletPiezoSpeakerV2BeepFrequency");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletPiezoSpeakerV2Beep":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Beep"), "Beep", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPiezoSpeakerV2Beep")).withDescription("Beeps with the configured default frequency and volume for the configured duration. Frequency and Volume can be updated using the corresponding channels.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletPiezoSpeakerV2Alarm":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Alarm"), "Alarm", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPiezoSpeakerV2Alarm")).withDescription("Creates an alarm (a tone that goes back and force between two specified frequencies). The following parameters can be set:<br/><br/><ul><li>Start Frequency: Start frequency of the alarm in Hz.</li></br><li>End Frequency: End frequency of the alarm in Hz.</li></br><li>Step Size: Size of one step of the sweep between the start/end frequencies in Hz.</li></br><li>Step Delay: Delay between two steps (duration of time that one tone is used in a sweep) in ms.</li></br><li>Duration: Duration of the alarm in ms.</li></ul></br><br/>A duration of 0 stops the current alarm if any is ongoing. A duration of 4294967295 results in an infinite alarm.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletPiezoSpeakerV2Volume":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Volume"), "Volume", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPiezoSpeakerV2Volume")).withDescription("Volume of an ongoing beep or alarm. The range of the volume is 0 to 10.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).withReadOnly(false).build().toStateDescription()).build();
            case "BrickletPiezoSpeakerV2BeepFrequency":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2BeepFrequency"), "Beep Frequency", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPiezoSpeakerV2BeepFrequency")).withDescription("Frequency of an ongoing beep. The range of the frequency is 50Hz to 15000Hz.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(50)).withMaximum(BigDecimal.valueOf(15000)).withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Piezo Speaker Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Creates beep and alarm with configurable volume and frequency").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletPiezoSpeakerV2Beep", new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Beep")).withLabel("Beep").build(), new ChannelDefinitionBuilder("BrickletPiezoSpeakerV2Alarm", new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Alarm")).withLabel("Alarm").build(), new ChannelDefinitionBuilder("BrickletPiezoSpeakerV2Volume", new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2Volume")).withLabel("Volume").build(), new ChannelDefinitionBuilder("BrickletPiezoSpeakerV2BeepFrequency", new ChannelTypeUID("tinkerforge", "BrickletPiezoSpeakerV2BeepFrequency")).withLabel("Beep Frequency").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletpiezospeakerv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletPiezoSpeakerV2Beep":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("defaultFrequency", Type.INTEGER).withDefault("2000").withDescription("The frequency in Hz to start the beep with. The range of the frequency is 50Hz to 15000Hz.").withLabel("Default Frequency").withMinimum(BigDecimal.valueOf(50)).withMaximum(BigDecimal.valueOf(15000)).build(), ConfigDescriptionParameterBuilder.create("defaultVolume", Type.INTEGER).withDefault("0").withDescription("The volume to start the beep with. The range of the volume is 0 to 10.").withLabel("Default Volume").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).build(), ConfigDescriptionParameterBuilder.create("duration", Type.DECIMAL).withDefault("0").withDescription("The duration in ms to beep for. A duration of 0 stops the current beep if any is ongoing. A duration of 4294967295 results in an infinite beep.").withLabel("Duration").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).withStepSize(BigDecimal.valueOf(1)).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletPiezoSpeakerV2Alarm":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("startFrequency", Type.INTEGER).withDefault("250").withDescription("Start frequency of the alarm in Hz. The range of the start frequency is 50Hz to 14999Hz. (has to be smaller than end frequency)").withLabel("Start Frequency").withMinimum(BigDecimal.valueOf(50)).withMaximum(BigDecimal.valueOf(14999)).build(), ConfigDescriptionParameterBuilder.create("endFrequency", Type.INTEGER).withDefault("750").withDescription("End frequency of the alarm in Hz. The range of the end frequency is 51Hz to 15000Hz. (has to be bigger than start frequency)").withLabel("End Frequency").withMinimum(BigDecimal.valueOf(51)).withMaximum(BigDecimal.valueOf(15000)).build(), ConfigDescriptionParameterBuilder.create("stepSize", Type.INTEGER).withDefault("1").withDescription("Size of one step of the sweep between the start/end frequencies in Hz. 1Hz - 65536Hz (has to be small enough to fit into the frequency range)").withLabel("Step Size").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(14950)).build(), ConfigDescriptionParameterBuilder.create("stepDelay", Type.INTEGER).withDefault("1").withDescription("Delay between two steps (duration of time that one tone is used in a sweep) in ms. 1ms - 65535ms (has to be small enough to fit into the duration)").withLabel("Step Delay").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(65535)).build(), ConfigDescriptionParameterBuilder.create("defaultVolume", Type.INTEGER).withDefault("0").withDescription("The volume to start the alarm with. The range of the volume is 0 to 10.").withLabel("Default Volume").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).build(), ConfigDescriptionParameterBuilder.create("duration", Type.INTEGER).withDefault("0").withDescription("The duration in ms to sound the alarm for. A duration of 0 stops the current alarm if any is ongoing. A duration of 4294967295 results in an infinite alarm.").withLabel("Duration").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletPiezoSpeakerV2Volume":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletPiezoSpeakerV2BeepFrequency":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletPiezoSpeakerV2Config cfg = (BrickletPiezoSpeakerV2Config) config.as(BrickletPiezoSpeakerV2Config.class);
        switch(channel) {
            case "BrickletPiezoSpeakerV2Beep": {
                   BrickletBrickletPiezoSpeakerV2BeepConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2BeepConfig.class);
                   {
            Beep value = this.getBeep();
            if(true)
                updateStateFn.accept(channel, transformBrickletPiezoSpeakerV2BeepGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletPiezoSpeakerV2Alarm": {
                   BrickletBrickletPiezoSpeakerV2AlarmConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2AlarmConfig.class);
                   {
            Alarm value = this.getAlarm();
            if(true)
                updateStateFn.accept(channel, transformBrickletPiezoSpeakerV2AlarmGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletPiezoSpeakerV2Volume": {
                   BrickletBrickletPiezoSpeakerV2VolumeConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2VolumeConfig.class);
                   {
            Beep value = this.getBeep();
            if(value.durationRemaining > 0)
                updateStateFn.accept(channel, transformBrickletPiezoSpeakerV2VolumeGetter0(value, cfg));
        }
                   {
            Alarm value = this.getAlarm();
            if(value.durationRemaining > 0)
                updateStateFn.accept(channel, transformBrickletPiezoSpeakerV2VolumeGetter1(value, cfg));
        }
                   return;
               }
            case "BrickletPiezoSpeakerV2BeepFrequency": {
                   BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig.class);
                   {
            Beep value = this.getBeep();
            if(value.durationRemaining > 0)
                updateStateFn.accept(channel, transformBrickletPiezoSpeakerV2BeepFrequencyGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletPiezoSpeakerV2Config cfg = (BrickletPiezoSpeakerV2Config) config.as(BrickletPiezoSpeakerV2Config.class);
        switch(channel) {
            case "BrickletPiezoSpeakerV2Beep":
                if (command instanceof OnOffType) {
                    BrickletBrickletPiezoSpeakerV2BeepConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2BeepConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setBeep(channelCfg.defaultFrequency, channelCfg.defaultVolume, cmd == OnOffType.ON ? channelCfg.duration.longValue() : 0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletPiezoSpeakerV2Volume", 0));
				result.add(new SetterRefresh("BrickletPiezoSpeakerV2BeepFrequency", 0));
                break;
            case "BrickletPiezoSpeakerV2Alarm":
                if (command instanceof OnOffType) {
                    BrickletBrickletPiezoSpeakerV2AlarmConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2AlarmConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setAlarm(channelCfg.startFrequency, channelCfg.endFrequency, channelCfg.stepSize, channelCfg.stepDelay, channelCfg.defaultVolume, cmd == OnOffType.ON ? channelCfg.duration : 0);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletPiezoSpeakerV2Volume", 0));
                break;
            case "BrickletPiezoSpeakerV2Volume":
                if (command instanceof Number) {
                    BrickletBrickletPiezoSpeakerV2VolumeConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2VolumeConfig.class);
                    Number cmd = (Number) command;
                    this.updateVolume(cmd.intValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletPiezoSpeakerV2BeepFrequency":
                if (command instanceof Number) {
                    BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig channelCfg = channelConfig.as(BrickletBrickletPiezoSpeakerV2BeepFrequencyConfig.class);
                    Number cmd = (Number) command;
                    this.updateFrequency(cmd.intValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2BeepCallback0(BrickletPiezoSpeakerV2Config cfg) {
        return OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2AlarmCallback0(BrickletPiezoSpeakerV2Config cfg) {
        return OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2BeepGetter0(Beep value, BrickletPiezoSpeakerV2Config cfg) {
        return value.durationRemaining > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2AlarmGetter0(Alarm value, BrickletPiezoSpeakerV2Config cfg) {
        return value.durationRemaining > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2VolumeGetter0(Beep value, BrickletPiezoSpeakerV2Config cfg) {
        return new DecimalType(value.volume);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2VolumeGetter1(Alarm value, BrickletPiezoSpeakerV2Config cfg) {
        return new DecimalType(value.volume);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPiezoSpeakerV2BeepFrequencyGetter0(Beep value, BrickletPiezoSpeakerV2Config cfg) {
        return new QuantityType<>(value.frequency, SmartHomeUnits.HERTZ);
    }
}
